// Generalization of Generations and Weighted Life Rule
//
// By Brian Prentice  May 2001
// Modified for new Dll interface by Mirek Wjtowicz  June 2001 

library WeightedGen;

uses
  SysUtils,
  Classes,
  Dialogs,
  Input in 'Input.pas' {InputDialog},
  uMWStrings in 'uMWStrings.pas';

var
  InputDialog: TInputDialog;

function GetWeight(Cell: Integer; Position: Integer): Integer;
begin
  GetWeight := StateWeights[Cell] * PositionWeights[Position]
end;

function CARule(Generation,col,row,
                NW,N, NE,
                W, Me,E,
                SW,S, SE: Integer): Integer; stdcall;
var
  Sum, I: Integer;
begin
  Sum := GetWeight(NW, 0) + GetWeight(N, 1) + GetWeight(NE, 2) +
         GetWeight(W, 3)  + GetWeight(E, 4) +
         GetWeight(SW, 5) + GetWeight(S, 6) + GetWeight(SE, 7);
  Result := 0;
  if Me = 0 then
  begin
    for I := 1 to BirthCount do
      if Sum = BirthList[I] then
      begin
        Result := 1;
        Exit
      end
  end;
  if Me = 1 then
  begin
    for I := 1 to SurvivalCount do
      if Sum = SurvivalList[I] then
      begin
        Result := 1;
        Exit
      end
  end;
  if (Me > 0) and (Me <> NumberOfStates - 1) then
    Result := Me + 1
end;

procedure CAConfig(var RuleType, CountOfColors: Integer; Rule: PChar;
                   Misc: PChar); stdcall;
begin
  InitRuleFromString(Rule);
  InputDialog := TInputDialog.Create(nil);
  InputDialog.ShowModal;
  InputDialog.Free;
  StrCopy(Rule, PChar(GetRuleAsString()));
  RuleType := 2;
  CountOfColors := NumberOfStates;
  StrCopy(Misc, '');
end;

procedure CASetup(var RuleType, CountOfColors: Integer; ColorPalette,
                  Misc: PChar); stdcall;
var
  iPos: Integer;
begin
  RuleType := 2;
  iPos := Pos('RULE=', Misc);
  if (iPos > 0) then
    InitRuleFromString(Copy(Misc, iPos + 5, Length(Misc) - iPos))
  else
    InitRuleFromString('');
  CountOfColors := NumberOfStates;
  StrCopy(ColorPalette, '')
end;

exports
  CARule   index 1,
  CASetup  index 2,
  CAConfig index 3;

begin
end.
